# Hoofdstuk-25-listing2506-uitgesplitst--OPLOSSING.py -- 9 re's voor 8 strings
# Uit Pieter Spronck: De programmeursleerling
# Variant door Meindert Meindertsma, 2023-05-22


import re

# List van strings die worden gebruikt voor testen.
slist = [ "aaabbb", "aaaaaa", "abbaba", "aaa", "bEver ottEr",
"tango samba rumba", " hello world ", " Hello World " ]

# Reguliere expressies die moeten worden ingevuld.
relist = [
    None,
    r"^a+b*$",            # 1. Alleen a's gevolgd door alleen b's, inclusief ""
    r"^a*$",              # 2. Alleen a's, inclusief ""
    r"^[ab]*$",           # 3. Alleen a's en b's, willekeurige volgorde, incl. ""
    r"^aaa$",             # 4. Precies drie a's
    r"^[^ab]*$",          # 5. Noch a's noch b's, maar "" is toegestaan
    r"^(aa)*$",           # 6. Een even aantal a's (en niks anders)
    r"^\W*\w+\W+\w+\W*$", # 7. Precies twee woorden, ongeacht spaties
    r"ba\b",              # 8. Bevat een woord dat op "ba" eindigt
    r"\b[A-Z]"            # 9. Bevat een woord dat begint met een hoofdletter
]

# Uitgesplitste presentatie.
for i in range(1, len( relist ) ):
# for i in (1,):
    print( f'Reguliere expressie {i} = "{relist[i]}":' )
    for s in slist:
        if m := re.search( relist[i], s ):
            gevonden = f'segment [{m.start(0)}:{m.end(0)}] = "{m.group(0)}"' \
                       f' voldoet aan re-{i} "{relist[i]}"'
        else:
            gevonden = ""
        print( f'''   {f'"{s}"' :19s}:''', gevonden )
    print()

